<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<fmt:bundle basename="org.wso2.carbon.humantask.ui.i18n.Resources">
<carbon:breadcrumb
        label="hi.packages"
        resourceBundle="org.wso2.carbon.humantask.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<%

    String pageNumber = request.getParameter("page");
    if (pageNumber == null || pageNumber.length() == 0) {
        if(session.getAttribute("hipkgpageNumber") == null){
            session.setAttribute("hipkgpageNumber", 0);
            pageNumber = "0";
        }else{
            pageNumber  = (session.getAttribute("hipkgpageNumber")).toString();
        }
    } else {
        int pageNum = Integer.parseInt(pageNumber);
        session.setAttribute("hipkgpageNumber", pageNum);
    }
%>
<script type="text/javascript" src="js/hi-main.js"></script>
<script type="text/javascript">
    //var taskList = "";
    var packageList = [];
    var taskList = {};
    var currPack = "";
    var currentPage = <%=pageNumber%>;
    var intObj;
    HI.deployment.loadPackageList = function() {
        var listPackageURL = "task_deploy-ajaxprocessor.jsp?operation=packages";

        jQuery.ajax({
            url: listPackageURL,
            dataType:'xml',
            type:'GET',
            error:function(xhr, textStatus, errorThrown) {
                if(textStatus != 'timeout'){
                    if(intObj){
                        clearInterval(intObj);
                    }
                }
            },
            success:HI.deployment.fillPackageList
        });
    };

    HI.deployment.undeploy = function(name) {
        var url = 'task_instance_exists-ajaxprocessor.jsp?name=' + name;
        function handleYes() {
            jQuery.get("manage_hi_packages-ajaxprocessor.jsp", {operation: "undeploy", packageName: name}, function(data) {
                if (jQuery(data).find('ERRORDIALOG').length != 0) {
                    CARBON.showErrorDialog(data);
                } else {
                    CARBON.showInfoDialog(data);
                }
                HI.deployment.loadPackageList();
                clearInterval(intObj);
                intObj = setInterval("HI.deployment.loadPackageList()", 10000);
            }, "html");
        }

        jQuery.ajax({
            url:url,
            dataType:'xml',
            type:'GET',
            error:function() {
                if (intObj) {
                    clearInterval(intObj);
                }
                CARBON.showErrorDialog("<fmt:message key="hi.error_occurred"/>");
            },
            success:function(xml) {
                if (jQuery(xml).find('HasTaskInstances').text().toLowerCase() == 'true') {
                    CARBON.showConfirmationDialog("<fmt:message key="want.to.undeploy.hi.package"/> " + name + "?", handleYes, null);
                } else {
                    CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.undeploy.package"/> " + name + "?", handleYes, null);
                }
            }
        });
    };

    HI.deployment.redeploy = function(name) {
        function handleYes() {
            jQuery.get("manage_hi_packages-ajaxprocessor.jsp", {operation: "redeploy", packageName: name}, function(data) {
                if (jQuery(data).find('ERRORDIALOG').length != 0) {
                    CARBON.showErrorDialog(data);
                } else {
                    CARBON.showInfoDialog(data);
                }
                HI.deployment.loadPackageList();
                clearInterval(intObj);
                intObj = setInterval("HI.deployment.loadPackageList()", 10000);
            }, "html");
        }

        CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.redeploy.package"/> " + name + "?", handleYes, null);
    };

    HI.deployment.removeDeployed = function(name) {
        var url = 'task_instance_exists-ajaxprocessor.jsp?name=' + name;
        function handleYes() {
            jQuery("#td" + name.replace("-", "_")).css("display", "none");
            jQuery.get("manage_hi_packages-ajaxprocessor.jsp", {operation: "delete", packageName: name}, function(data) {
                if (jQuery(data).find('ERRORDIALOG').length != 0) {
                    CARBON.showErrorDialog(data);
                } else {
                    CARBON.showInfoDialog(data);
                }
                //HI.deployment.loadPackageList();
                clearInterval(intObj);
                intObj = setInterval("HI.deployment.loadPackageList()", 10000);
            }, "html");
        }

        jQuery.ajax({
            url:url,
            dataType:'xml',
            type:'GET',
            error:function() {
                if (intObj) {
                    clearInterval(intObj);
                }
                CARBON.showErrorDialog("<fmt:message key="hi.error_occurred"/>");
            },
            success:function(xml) {
                if (jQuery(xml).find('HasTaskInstances').text().toLowerCase() == 'true') {
                    CARBON.showConfirmationDialog("<fmt:message key="want.to.delete.hi.package"/> " + name + "?", handleYes, null);
                } else {
                    CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.delete.package"/> " + name + "?", handleYes, null);
                }
            }
        });
    };
    /*
    HI.deployment.removeUndeployed = function(name) {
        function handleYes() {
            jQuery("#td" + name.replace("-", "_")).css("display", "none");
            jQuery.get("manage_hi_packages-ajaxprocessor.jsp", {operation: "delete", packageName: name}, function(data) {
                if (jQuery(data).find('ERRORDIALOG').length != 0) {
                    CARBON.showErrorDialog(data);
                } else {
                    CARBON.showInfoDialog(data);
                }
                //HI.deployment.loadPackageList();
                clearInterval(intObj);
                intObj = setInterval("HI.deployment.loadPackageList()", 10000);
            }, "html");
        }

        CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.delete.package"/> " + name + "?", handleYes, null);
    };
     */
    HI.deployment.fillPackageList = function(xml) {
        var scriptID = "undeployScript";
        var script = "";

        if (jQuery(xml).find('Pages').text() == "0" || $(xml).find('Pages').text() == undefined || $(xml).find('Pages').text() == null) {
            if($(xml).find('Pages').text() == undefined || $(xml).find('Pages').text() == null){
                jQuery("#package_list").html("<p><fmt:message key="error.occured.while.getting.packages.list"/></p>");        //this vaule need to defined in the resource file
             }else{
                jQuery("#package_list").html("<p><fmt:message key="there.are.no.deployed.packages"/></p>");
             }
            jQuery("#hiListPagesUp").html("");
            jQuery("#hiListPagesDown").html("");
            return true;
        } else {
            var pages = parseInt(jQuery(xml).find('Pages').text());
            var pagesHTML = "<table><tr>";
            currentPage = jQuery(xml).find('PageNumber').text();
            if (pages > 1) {
                if (currentPage > 0) {
                    pagesHTML += "<td><strong><a href='hi_packages.jsp?page=" + (parseInt(currentPage) - 1) +
                                 "'>&lt;&nbsp;prev&nbsp;&nbsp;</a></strong></td>";
                }
                for (var i = 0; i < pages; i++) {
                    if (i == currentPage) {
                        pagesHTML += "<td><strong>" + (i + 1) + "&nbsp;&nbsp;</strong></td>";
                    } else {
                        pagesHTML += "<td><strong><a href='hi_packages.jsp?page=" + i + "'>" + (i + 1) + " &nbsp;&nbsp;</a></strong></td>";
                    }
                }
                if (currentPage < (pages - 1)) {
                    pagesHTML += "<td><strong><a href='hi_packages.jsp?page=" + (parseInt(currentPage) + 1) +
                                 "'>&lt;&nbsp;next&nbsp;&gt;&nbsp;</a></strong></td>";
                }
            }
            pagesHTML += "</tr></table>";

            jQuery("#hiListPagesUp").html(pagesHTML);
            jQuery("#hiListPagesDown").html(pagesHTML);

        }

        //var tableHTML = "<table id='packageListTable' class='styledLeft' width='100%'><thead><th><fmt:message key="hi.package"/></th><th><fmt:message key="hi.tasks"/></th><th></th><th></th></thead><tbody>";
        var tableHTML = "<table id='packageListTable' class='styledLeft' width='100%'><thead><th><fmt:message key="hi.package"/></th><th></th></thead><tbody>";
        jQuery(xml).find('Package').each(function(index) {
            var deploymentType = "";
            if (jQuery(this).find('Status').text() != 'UNDEPLOYED') {
                script += "function unOrDeployPackage" + jQuery(this).find('Name').text().replace("-", "_") + "(){HI.deployment.undeploy('" + jQuery(this).find('Name').text() + "');return false;}";
                script += "function deletePackage" + jQuery(this).find('Name').text().replace("-", "_") + "(){HI.deployment.removeDeployed('" + jQuery(this).find('Name').text() + "');return false;}";
                deploymentType = "Undeploy";
            }
            else {
                script += "function deletePackage" + jQuery(this).find('Name').text().replace("-", "_") + "(){HI.deployment.removeUndeployed('" + jQuery(this).find('Name').text() + "');return false;}";
                script += "function unOrDeployPackage" + jQuery(this).find('Name').text().replace("-", "_") + "(){HI.deployment.redeploy('" + jQuery(this).find('Name').text() + "');return false;}";
                deploymentType = "Redeploy";
            }

            tableHTML += "<tr id='td" + jQuery(this).find('Name').text().replace("-", "_") + "'><td>" + jQuery(this).find('Name').text() +
                         "</td>";
//            tableHTML += "<tr id='td" + jQuery(this).find('Name').text().replace("-", "_") + "'><td>" + jQuery(this).find('Name').text() +
//                         "</td><td>" + jQuery(this).find('Tasks').text() +
//                         "</td><td><a href='#' class='icon-link'";
//            if (deploymentType == 'Undeploy') {
//                tableHTML += " style='background-image:url(images/undeploy.gif);'";
//            } else {
//                tableHTML += " style='background-image:url(images/redeploy.gif);'";
//            }
            <%--tableHTML += " onclick='unOrDeployPackage" + jQuery(this).find('Name').text().replace("-", "_") +--%>
                         <%--"()'>" + deploymentType + "</a></td>" +--%>
                         <%--"<td><a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='deletePackage" +--%>
                         <%--jQuery(this).find('Name').text().replace("-", "_") + "()'><fmt:message key="hi.delete"/></a></td>";--%>
        <%--});--%>
        tableHTML += "<td><a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='deletePackage" +
                         jQuery(this).find('Name').text().replace("-", "_") + "()'><fmt:message key="hi.delete"/></a></td>";
        });
        tableHTML += "</tbody></table>";

        jQuery("#package_list").html(tableHTML);

        alternateTableRows('packageListTable', 'tableEvenRow', 'tableOddRow');

        var headID = document.getElementsByTagName("head")[0];
        var newScript = document.createElement('script');
        newScript.type = 'text/javascript';
        newScript.setAttribute('id', scriptID);
        var oldScriptEle = document.getElementById(scriptID);
        if (null == newScript.canHaveChildren || newScript.canHaveChildren) {
            newScript.appendChild(document.createTextNode(script));
        } else {
            newScript.text = script;
        }

        if (oldScriptEle) {
            headID.replaceChild(newScript, oldScriptEle);
        } else {
            headID.appendChild(newScript);
        }
    };

    jQuery(document).ready(function() {
        HI.deployment.loadPackageList();
        intObj = setInterval("HI.deployment.loadPackageList()", 10000);
    });
</script>
<style type="text/css">
    table.styledLeft thead th {
        padding-bottom: 0;
        padding-top: 0;
        padding-right: 0;
    }
</style>
<div id="middle">

    <h2 class="depn"><fmt:message key="hi.headertext_deployed_packages"/></h2>

    <div id="workArea">
        <div id="hiListPagesUp"></div>
        <p>&nbsp;</p>

        <div id="package_list">
        </div>

        <p>&nbsp;</p>

        <div id="hiListPagesDown"></div>
    </div>
</div>
</fmt:bundle>
