<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="javax.xml.transform.Result" %>
<%@ page import="javax.xml.transform.stream.StreamResult" %>
<%@ page import="org.wso2.carbon.wsdl2form.WSDL2FormGenerator" %>
<%@ page import="org.wso2.carbon.CarbonException" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    String taskId = request.getParameter("taskId");
    String tryitServiceName = request.getParameter("tryitServiceName");
    String tryitOperationName = request.getParameter("tryitOperationName");
    String tryitWsdlUrl = backendServerURL + tryitServiceName + "?wsdl2";

    Log log = LogFactory.getLog("tryit.ajaxprocessor");

    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    PrintWriter printWriter = response.getWriter();

    try {
        Result result = new StreamResult(printWriter);
        String str = WSDL2FormGenerator.getInstance().
                getInternalMockit(result, tryitWsdlUrl, tryitServiceName, tryitOperationName,
                        taskId, "/carbon/humantask/task_dispatch-ajaxprocessor.jsp", false);
        if(!str.equals(WSDL2FormGenerator.SUCCESS)) {
            log.info("ReDirecting to " + str);
            response.sendRedirect(str);
        }
    } catch (CarbonException e) {
        log.error(e);
        response.setContentType("text/html; charset=utf-8");
        if (e.getMessage().equals(WSDL2FormGenerator.SERVICE_INACTIVE)) {
            response.setStatus(HttpServletResponse.SC_NOT_FOUND);
            printWriter
                    .write(("<h4>Requested Service is inactive. Cannot generate stubs.</h4>"));
            printWriter.flush();
            return;
        } else if (e.getMessage().equals(WSDL2FormGenerator.SERVICE_NOT_FOUND)) {
            response.setStatus(HttpServletResponse.SC_SERVICE_UNAVAILABLE);
            printWriter
                    .write(("<h4>Service cannot be found. Cannot display <em>Stub</em>.</h4>"));
            printWriter.flush();
            return;
        } else {
            response.sendError(HttpServletResponse.SC_NOT_FOUND);
            response.setContentType("text/html; charset=utf-8");
            printWriter.write(
                    ("<h4>" + e.getMessage() + "</h4>"));
            printWriter.flush();
            return;
        }
    }
    printWriter.flush();

%>
